-- Do not edit.  Generated by cheby 1.7.dev0 using these options:
--  --header commit --gen-hdl host_map.vhd --gen-c ../../sw/hw-include/host_map.h -i host_map.cheby


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

package host_map_pkg is
  type t_intc_master_out is record
    tm_timer_cycles  : std_logic_vector(27 downto 0);
    tm_timer_sec     : std_logic_vector(3 downto 0);
    imr_clock        : std_logic;
    imr_timer        : std_logic;
    imr_wr_sync      : std_logic;
    imr_msg          : std_logic;
    imr_async        : std_logic;
    iack_clock       : std_logic;
    iack_timer       : std_logic;
    iack_wr_sync     : std_logic;
    iack_msg         : std_logic;
    iack_async       : std_logic;
    iack_wr          : std_logic;
  end record t_intc_master_out;
  subtype t_intc_slave_in is t_intc_master_out;

  type t_intc_slave_out is record
    tm_compact_cycles : std_logic_vector(27 downto 0);
    tm_compact_sec   : std_logic_vector(3 downto 0);
    isr_clock        : std_logic;
    isr_timer        : std_logic;
    isr_wr_sync      : std_logic;
    isr_msg          : std_logic;
    isr_async        : std_logic;
    isr_raw_clock    : std_logic;
    isr_raw_timer    : std_logic;
    isr_raw_wr_sync  : std_logic;
    isr_raw_msg      : std_logic;
    isr_raw_async    : std_logic;
  end record t_intc_slave_out;
  subtype t_intc_master_in is t_intc_slave_out;

end host_map_pkg;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;
use work.host_map_pkg.all;

entity host_map is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- Identification (WREN)
    ident_i              : in    std_logic_vector(31 downto 0);

    -- Map version
    map_version_i        : in    std_logic_vector(31 downto 0);

    -- Model identification (vmeN, pciN, pxeN)
    model_id_i           : in    std_logic_vector(31 downto 0);

    -- Firmware version
    fw_version_i         : in    std_logic_vector(31 downto 0);

    -- WhiteRabbit status
    wr_state_link_up_i   : in    std_logic;
    wr_state_time_valid_i : in    std_logic;

    -- TAI (seconds) lo part
    tm_tai_lo_i          : in    std_logic_vector(31 downto 0);

    -- TAI (seconds) hi part
    tm_tai_hi_i          : in    std_logic_vector(31 downto 0);

    -- TAI cycles
    tm_cycles_i          : in    std_logic_vector(31 downto 0);
    intc_i               : in    t_intc_master_in;
    intc_o               : out   t_intc_master_out;

    -- SRAM bus buildinfo
    buildinfo_addr_o     : out   std_logic_vector(7 downto 2);
    buildinfo_data_i     : in    std_logic_vector(31 downto 0);
    buildinfo_data_o     : out   std_logic_vector(31 downto 0);
    buildinfo_wr_o       : out   std_logic;

    -- Address in DDR of the next entry to be written
    logs_addr_adr_o      : out   std_logic_vector(8 downto 2);
    logs_addr_dato_i     : in    std_logic_vector(31 downto 0);
    logs_addr_dati_o     : out   std_logic_vector(31 downto 0);
    logs_addr_rd_o       : out   std_logic;
    logs_addr_wr_o       : out   std_logic;
    logs_addr_rack_i     : in    std_logic;
    logs_addr_wack_i     : in    std_logic;

    -- WB bus wrpc
    wrpc_i               : in    t_wishbone_master_in;
    wrpc_o               : out   t_wishbone_master_out
  );
end host_map;

architecture syn of host_map is
  signal wr_sel                         : std_logic_vector(31 downto 0);
  signal adr_int                        : std_logic_vector(12 downto 2);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal intc_tm_timer_cycles_reg       : std_logic_vector(27 downto 0);
  signal intc_tm_timer_sec_reg          : std_logic_vector(3 downto 0);
  signal intc_tm_timer_wreq             : std_logic;
  signal intc_tm_timer_wack             : std_logic;
  signal intc_imr_clock_reg             : std_logic;
  signal intc_imr_timer_reg             : std_logic;
  signal intc_imr_wr_sync_reg           : std_logic;
  signal intc_imr_msg_reg               : std_logic;
  signal intc_imr_async_reg             : std_logic;
  signal intc_imr_wreq                  : std_logic;
  signal intc_imr_wack                  : std_logic;
  signal intc_iack_wreq                 : std_logic;
  signal buildinfo_rack                 : std_logic;
  signal buildinfo_re                   : std_logic;
  signal wrpc_re                        : std_logic;
  signal wrpc_we                        : std_logic;
  signal wrpc_wt                        : std_logic;
  signal wrpc_rt                        : std_logic;
  signal wrpc_tr                        : std_logic;
  signal wrpc_wack                      : std_logic;
  signal wrpc_rack                      : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(12 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_sel_d0                      : std_logic_vector(31 downto 0);
  signal buildinfo_wp                   : std_logic;
  signal buildinfo_we                   : std_logic;
  signal logs_addr_ws                   : std_logic;
  signal logs_addr_wt                   : std_logic;
begin

  -- WB decode signals
  process (wb_i.sel) begin
    wr_sel(7 downto 0) <= (others => wb_i.sel(0));
    wr_sel(15 downto 8) <= (others => wb_i.sel(1));
    wr_sel(23 downto 16) <= (others => wb_i.sel(2));
    wr_sel(31 downto 24) <= (others => wb_i.sel(3));
  end process;
  adr_int <= wb_i.adr(12 downto 2);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wb_o.dat <= "00000000000000000000000000000000";
        wr_req_d0 <= '0';
        wr_adr_d0 <= "00000000000";
        wr_dat_d0 <= "00000000000000000000000000000000";
        wr_sel_d0 <= "00000000000000000000000000000000";
      else
        rd_ack_int <= rd_ack_d0;
        wb_o.dat <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= adr_int;
        wr_dat_d0 <= wb_i.dat;
        wr_sel_d0 <= wr_sel;
      end if;
    end if;
  end process;

  -- Register ident

  -- Register map_version

  -- Register model_id

  -- Register fw_version

  -- Register wr_state

  -- Register tm_tai_lo

  -- Register tm_tai_hi

  -- Register tm_cycles

  -- Register intc_tm_compact

  -- Register intc_tm_timer
  intc_o.tm_timer_cycles <= intc_tm_timer_cycles_reg;
  intc_o.tm_timer_sec <= intc_tm_timer_sec_reg;
  intc_tm_timer_wack <= intc_tm_timer_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        intc_tm_timer_cycles_reg <= "0000000000000000000000000000";
        intc_tm_timer_sec_reg <= "0000";
      else
        if intc_tm_timer_wreq = '1' then
          intc_tm_timer_cycles_reg <= wr_dat_d0(27 downto 0);
          intc_tm_timer_sec_reg <= wr_dat_d0(31 downto 28);
        end if;
      end if;
    end if;
  end process;

  -- Register intc_isr

  -- Register intc_isr_raw

  -- Register intc_imr
  intc_o.imr_clock <= intc_imr_clock_reg;
  intc_o.imr_timer <= intc_imr_timer_reg;
  intc_o.imr_wr_sync <= intc_imr_wr_sync_reg;
  intc_o.imr_msg <= intc_imr_msg_reg;
  intc_o.imr_async <= intc_imr_async_reg;
  intc_imr_wack <= intc_imr_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        intc_imr_clock_reg <= '0';
        intc_imr_timer_reg <= '0';
        intc_imr_wr_sync_reg <= '0';
        intc_imr_msg_reg <= '0';
        intc_imr_async_reg <= '0';
      else
        if intc_imr_wreq = '1' then
          intc_imr_clock_reg <= wr_dat_d0(0);
          intc_imr_timer_reg <= wr_dat_d0(1);
          intc_imr_wr_sync_reg <= wr_dat_d0(2);
          intc_imr_msg_reg <= wr_dat_d0(3);
          intc_imr_async_reg <= wr_dat_d0(4);
        end if;
      end if;
    end if;
  end process;

  -- Register intc_iack
  intc_o.iack_clock <= wr_dat_d0(0);
  intc_o.iack_timer <= wr_dat_d0(1);
  intc_o.iack_wr_sync <= wr_dat_d0(2);
  intc_o.iack_msg <= wr_dat_d0(3);
  intc_o.iack_async <= wr_dat_d0(4);
  intc_o.iack_wr <= intc_iack_wreq;

  -- Interface buildinfo
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        buildinfo_rack <= '0';
      else
        buildinfo_rack <= buildinfo_re and not buildinfo_rack;
      end if;
    end if;
  end process;
  buildinfo_data_o <= wr_dat_d0;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        buildinfo_wp <= '0';
      else
        buildinfo_wp <= (wr_req_d0 or buildinfo_wp) and rd_req_int;
      end if;
    end if;
  end process;
  buildinfo_we <= (wr_req_d0 or buildinfo_wp) and not rd_req_int;
  process (adr_int, wr_adr_d0, buildinfo_re) begin
    if buildinfo_re = '1' then
      buildinfo_addr_o <= adr_int(7 downto 2);
    else
      buildinfo_addr_o <= wr_adr_d0(7 downto 2);
    end if;
  end process;

  -- Interface logs_addr
  logs_addr_dati_o <= wr_dat_d0;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        logs_addr_wt <= '0';
      else
        logs_addr_wt <= (logs_addr_wt or logs_addr_ws) and not logs_addr_wack_i;
      end if;
    end if;
  end process;
  logs_addr_wr_o <= logs_addr_ws;
  process (adr_int, wr_adr_d0, logs_addr_wt, logs_addr_ws) begin
    if (logs_addr_ws or logs_addr_wt) = '1' then
      logs_addr_adr_o <= wr_adr_d0(8 downto 2);
    else
      logs_addr_adr_o <= adr_int(8 downto 2);
    end if;
  end process;

  -- Interface wrpc
  wrpc_tr <= wrpc_wt or wrpc_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wrpc_rt <= '0';
        wrpc_wt <= '0';
      else
        wrpc_rt <= (wrpc_rt or wrpc_re) and not wrpc_rack;
        wrpc_wt <= (wrpc_wt or wrpc_we) and not wrpc_wack;
      end if;
    end if;
  end process;
  wrpc_o.cyc <= wrpc_tr;
  wrpc_o.stb <= wrpc_tr;
  wrpc_wack <= wrpc_i.ack and wrpc_wt;
  wrpc_rack <= wrpc_i.ack and wrpc_rt;
  wrpc_o.adr <= ((19 downto 0 => '0') & adr_int(11 downto 2)) & (1 downto 0 => '0');
  process (wr_sel_d0) begin
    wrpc_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      wrpc_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      wrpc_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      wrpc_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      wrpc_o.sel(3) <= '1';
    end if;
  end process;
  wrpc_o.we <= wrpc_wt;
  wrpc_o.dat <= wr_dat_d0;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, intc_tm_timer_wack, intc_imr_wack, buildinfo_we,
           logs_addr_wack_i, wrpc_wack) begin
    intc_tm_timer_wreq <= '0';
    intc_imr_wreq <= '0';
    intc_iack_wreq <= '0';
    buildinfo_wr_o <= '0';
    logs_addr_ws <= '0';
    wrpc_we <= '0';
    case wr_adr_d0(12 downto 12) is
    when "0" =>
      case wr_adr_d0(11 downto 9) is
      when "000" =>
        case wr_adr_d0(8 downto 8) is
        when "0" =>
          case wr_adr_d0(7 downto 2) is
          when "000000" =>
            -- Reg ident
            wr_ack_int <= wr_req_d0;
          when "000001" =>
            -- Reg map_version
            wr_ack_int <= wr_req_d0;
          when "000010" =>
            -- Reg model_id
            wr_ack_int <= wr_req_d0;
          when "000011" =>
            -- Reg fw_version
            wr_ack_int <= wr_req_d0;
          when "000100" =>
            -- Reg wr_state
            wr_ack_int <= wr_req_d0;
          when "000101" =>
            -- Reg tm_tai_lo
            wr_ack_int <= wr_req_d0;
          when "000110" =>
            -- Reg tm_tai_hi
            wr_ack_int <= wr_req_d0;
          when "000111" =>
            -- Reg tm_cycles
            wr_ack_int <= wr_req_d0;
          when "001000" =>
            -- Reg intc_tm_compact
            wr_ack_int <= wr_req_d0;
          when "001001" =>
            -- Reg intc_tm_timer
            intc_tm_timer_wreq <= wr_req_d0;
            wr_ack_int <= intc_tm_timer_wack;
          when "001010" =>
            -- Reg intc_isr
            wr_ack_int <= wr_req_d0;
          when "001011" =>
            -- Reg intc_isr_raw
            wr_ack_int <= wr_req_d0;
          when "001100" =>
            -- Reg intc_imr
            intc_imr_wreq <= wr_req_d0;
            wr_ack_int <= intc_imr_wack;
          when "001101" =>
            -- Reg intc_iack
            intc_iack_wreq <= wr_req_d0;
            wr_ack_int <= wr_req_d0;
          when others =>
            wr_ack_int <= wr_req_d0;
          end case;
        when "1" =>
          -- Submap buildinfo
          buildinfo_wr_o <= buildinfo_we;
          wr_ack_int <= buildinfo_we;
        when others =>
          wr_ack_int <= wr_req_d0;
        end case;
      when "110" =>
        -- Memory logs_addr
        logs_addr_ws <= wr_req_d0;
        wr_ack_int <= logs_addr_wack_i;
      when others =>
        wr_ack_int <= wr_req_d0;
      end case;
    when "1" =>
      -- Submap wrpc
      wrpc_we <= wr_req_d0;
      wr_ack_int <= wrpc_wack;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (adr_int, rd_req_int, ident_i, map_version_i, model_id_i, fw_version_i,
           wr_state_link_up_i, wr_state_time_valid_i, tm_tai_lo_i, tm_tai_hi_i,
           tm_cycles_i, intc_i.tm_compact_cycles, intc_i.tm_compact_sec,
           intc_tm_timer_cycles_reg, intc_tm_timer_sec_reg, intc_i.isr_clock,
           intc_i.isr_timer, intc_i.isr_wr_sync, intc_i.isr_msg,
           intc_i.isr_async, intc_i.isr_raw_clock, intc_i.isr_raw_timer,
           intc_i.isr_raw_wr_sync, intc_i.isr_raw_msg, intc_i.isr_raw_async,
           intc_imr_clock_reg, intc_imr_timer_reg, intc_imr_wr_sync_reg,
           intc_imr_msg_reg, intc_imr_async_reg, buildinfo_data_i,
           buildinfo_rack, logs_addr_dato_i, logs_addr_rack_i, wrpc_i.dat,
           wrpc_rack) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    buildinfo_re <= '0';
    logs_addr_rd_o <= '0';
    wrpc_re <= '0';
    case adr_int(12 downto 12) is
    when "0" =>
      case adr_int(11 downto 9) is
      when "000" =>
        case adr_int(8 downto 8) is
        when "0" =>
          case adr_int(7 downto 2) is
          when "000000" =>
            -- Reg ident
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= ident_i;
          when "000001" =>
            -- Reg map_version
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= map_version_i;
          when "000010" =>
            -- Reg model_id
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= model_id_i;
          when "000011" =>
            -- Reg fw_version
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= fw_version_i;
          when "000100" =>
            -- Reg wr_state
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= wr_state_link_up_i;
            rd_dat_d0(1) <= wr_state_time_valid_i;
            rd_dat_d0(31 downto 2) <= (others => '0');
          when "000101" =>
            -- Reg tm_tai_lo
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= tm_tai_lo_i;
          when "000110" =>
            -- Reg tm_tai_hi
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= tm_tai_hi_i;
          when "000111" =>
            -- Reg tm_cycles
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= tm_cycles_i;
          when "001000" =>
            -- Reg intc_tm_compact
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(27 downto 0) <= intc_i.tm_compact_cycles;
            rd_dat_d0(31 downto 28) <= intc_i.tm_compact_sec;
          when "001001" =>
            -- Reg intc_tm_timer
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(27 downto 0) <= intc_tm_timer_cycles_reg;
            rd_dat_d0(31 downto 28) <= intc_tm_timer_sec_reg;
          when "001010" =>
            -- Reg intc_isr
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= intc_i.isr_clock;
            rd_dat_d0(1) <= intc_i.isr_timer;
            rd_dat_d0(2) <= intc_i.isr_wr_sync;
            rd_dat_d0(3) <= intc_i.isr_msg;
            rd_dat_d0(4) <= intc_i.isr_async;
            rd_dat_d0(31 downto 5) <= (others => '0');
          when "001011" =>
            -- Reg intc_isr_raw
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= intc_i.isr_raw_clock;
            rd_dat_d0(1) <= intc_i.isr_raw_timer;
            rd_dat_d0(2) <= intc_i.isr_raw_wr_sync;
            rd_dat_d0(3) <= intc_i.isr_raw_msg;
            rd_dat_d0(4) <= intc_i.isr_raw_async;
            rd_dat_d0(31 downto 5) <= (others => '0');
          when "001100" =>
            -- Reg intc_imr
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= intc_imr_clock_reg;
            rd_dat_d0(1) <= intc_imr_timer_reg;
            rd_dat_d0(2) <= intc_imr_wr_sync_reg;
            rd_dat_d0(3) <= intc_imr_msg_reg;
            rd_dat_d0(4) <= intc_imr_async_reg;
            rd_dat_d0(31 downto 5) <= (others => '0');
          when "001101" =>
            -- Reg intc_iack
            rd_ack_d0 <= rd_req_int;
          when others =>
            rd_ack_d0 <= rd_req_int;
          end case;
        when "1" =>
          -- Submap buildinfo
          rd_dat_d0 <= buildinfo_data_i;
          rd_ack_d0 <= buildinfo_rack;
          buildinfo_re <= rd_req_int;
        when others =>
          rd_ack_d0 <= rd_req_int;
        end case;
      when "110" =>
        -- Memory logs_addr
        logs_addr_rd_o <= rd_req_int;
        rd_dat_d0 <= logs_addr_dato_i;
        rd_ack_d0 <= logs_addr_rack_i;
      when others =>
        rd_ack_d0 <= rd_req_int;
      end case;
    when "1" =>
      -- Submap wrpc
      wrpc_re <= rd_req_int;
      rd_dat_d0 <= wrpc_i.dat;
      rd_ack_d0 <= wrpc_rack;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
